using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;
using Syncfusion.Windows.Forms.Diagram;

namespace Diagram_WF_DiagramCtrlAdditiobn
{
    public partial class Form1 : Form
    {
        SymbolPalette palette = new SymbolPalette();
        public Form1()
        {
            InitializeComponent();
        }

        private void Form1_Load(object sender, EventArgs e)
        {
            Ellipse button = new Ellipse(0, 0, 75, 50);
            button.FillStyle.Color = Color.Transparent;
            button.Name = "Button";
            Ellipse label = new Ellipse(0, 0, 75, 50);
            label.FillStyle.Color = Color.Transparent;
            label.Name = "Label";
            Ellipse textBox = new Ellipse(0, 0, 75, 50);
            textBox.FillStyle.Color = Color.Transparent;
            textBox.Name = "TextBox";

            this.palette.AppendChild(button);
            this.palette.AppendChild(label);
            this.palette.AppendChild(textBox);

            this.paletteGroupView1.LoadPalette(palette);

            this.diagram1.MouseMove += new MouseEventHandler(diagram1_MouseMove);
            this.diagram1.DragDrop += new DragEventHandler(diagram1_DragDrop);
            this.diagram1.Model.EventSink.NodeCollectionChanging += new CollectionExEventHandler(EventSink_NodeCollectionChanging);

            this.diagram1.ControlAdded += new ControlEventHandler(diagram1_ControlAdded);
            this.diagram1.ControlRemoved += new ControlEventHandler(diagram1_ControlRemoved);
        }

        void diagram1_ControlRemoved(object sender, ControlEventArgs e)
        {
            Console.WriteLine(e.Control.Name + " was removed from Diagram control");
        }

        void diagram1_ControlAdded(object sender, ControlEventArgs e)
        {
            Console.WriteLine(e.Control.Name + " was added to Diagram control");
        }

        void diagram1_DragDrop(object sender, DragEventArgs e)
        {
            Point pt = new Point(Convert.ToInt32(this.diagram1.Controller.MouseLocation.X), Convert.ToInt32(this.diagram1.Controller.MouseLocation.Y));
            if (lab != null)
            {
                this.diagram1.Controls.Add(lab);
                lab.Location = pt;
            }
            if (btn != null)
            {
                this.diagram1.Controls.Add(btn);
                btn.Location = pt;
            }
            if (tBox != null)
            {
                this.diagram1.Controls.Add(tBox);
                tBox.Location = pt;
            }
            lab = null;
            tBox = null;
            btn = null;
        }

        System.Windows.Forms.Label lab;
        Button btn;
        TextBox tBox;
        void EventSink_NodeCollectionChanging(CollectionExEventArgs evtArgs)
        {
            Node node = evtArgs.Element as Node;
            if (node != null)
            {
                switch (node.Name)
                {
                    case "Label":
                        lab = new System.Windows.Forms.Label();
                        lab.Name = "Label";
                        lab.Text = "This is a new Label";
                        lab.AutoSize = true;
                        break;
                    case "Button":
                        btn = new Button();
                        btn.Name = "Button";
                        btn.Text = "This is a new button";
                        btn.AutoSize = true;
                        break;
                    case "TextBox":
                        tBox = new TextBox();
                        tBox.Name = "TextBox";
                        tBox.Text = "This is a new text Box";
                        break;
                }
                evtArgs.Cancel = true;
            }
        }

        void diagram1_MouseMove(object sender, MouseEventArgs e)
        {
            this.Text = e.Location.ToString();
        }

        private void button1_Click(object sender, EventArgs e)
        {
            foreach(Control ctrl in this.diagram1.Controls)
            {
                if (ctrl is TextBox)
                {
                    this.diagram1.Controls.RemoveByKey(ctrl.Name);
                    return;
                }
            }
            MessageBox.Show("No TextBox");
        }

        private void button2_Click(object sender, EventArgs e)
        {
            foreach (Control ctrl in this.diagram1.Controls)
            {
                if (ctrl is System.Windows.Forms.Label)
                {
                    this.diagram1.Controls.RemoveByKey(ctrl.Name);
                    return;
                }
            }
            MessageBox.Show("No Label");
        }

        private void button3_Click(object sender, EventArgs e)
        {
            foreach (Control ctrl in this.diagram1.Controls)
            {
                if (ctrl is Button)
                {
                    this.diagram1.Controls.RemoveByKey(ctrl.Name);
                    return;
                }
            }
            MessageBox.Show("No Button");
        }
    }
}